using GMW_data;
using SteamWare;
using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GMW.WebUserControls
{
  public partial class mod_lavMeccOUT : System.Web.UI.UserControl
  {
    /// <summary>
    /// flusso associato (hard coded) a FUSI
    /// </summary>
    protected string flusso = "FI";
    /// <summary>
    /// stato associato (hard coded) a  FUSI
    /// </summary>
    protected string statoUDC = "Fin";
    /// <summary>
    /// tipo di evento associato alla creazione dell'UDC
    /// </summary>
    protected string eventoUDC = "UDC_FINITO";
    /// <summary>
    /// dati x verifica CodSoggetto / matricola
    /// </summary>
    protected string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
    /// <summary>
    /// stringa degli UDC selezionati per consumo COMPLETO (nel formato #UDC1##UDC2#)
    /// </summary>
    protected string udcSelC
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("UdcSelC_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("UdcSelC_{0}", uid), value);
      }
    }
    /// <summary>
    /// stringa degli UDC selezionati per consumo PARZIALE (nel formato #UDC1##UDC2#)
    /// </summary>
    protected string udcSelP
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("UdcSelP_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("UdcSelP_{0}", uid), value);
      }
    }
    public event EventHandler eh_nuovaRicerca;
    public event EventHandler eh_reqUpdate;
    /// <summary>
    /// stringa UID univoca
    /// </summary>
    public string uid
    {
      get
      {
        return this.UniqueID.Replace("$", "_").Replace("-", "_");
      }
    }
    /// <summary>
    /// caricamento pagina
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
      {
        Postazione.messaggiText = "";
        Postazione.warningText = "";
        fixRicercaUdc();
        traduciObj();
        idxCella = Postazione.currIdxCella;
        checkNumKeyIn();
      }
      doChecks();
    }
    /// <summary>
    /// verifico se ci sia in sessione un input da NumKeyb e nel caso lometto in barcodeIn e processo...
    /// </summary>
    private void checkNumKeyIn()
    {
      if (memLayer.ML.isInSessionObject("numKeyIn"))
      {
        barcodeIn = memLayer.ML.StringSessionObj("numKeyIn");
        // svuoto valore in sessione...
        memLayer.ML.emptySessionVal("numKeyIn");
        // controllo barcode...
        checkBarcode();
      }
    }
    /// <summary>
    /// IDX cella associata alla linea corrente
    /// </summary>
    protected int idxCella
    {
      get
      {
        int answ = 0;
        if (memLayer.ML.isInSessionObject("IdxCellaLineaLM_OUT"))
        {
          answ = memLayer.ML.IntSessionObj("IdxCellaLineaLM_OUT");
        }
        return answ;
      }
      set
      {
        memLayer.ML.setSessionVal("IdxCellaLineaLM_OUT", value);
      }
    }
    /// <summary>
    /// verifica se si debba mostrare un campo ricerca attivo...
    /// </summary>
    private void fixRicercaUdc()
    {
      if (memLayer.ML.isInSessionObject("valoreCercatoLMO"))
      {
        testoRicerca = memLayer.ML.StringSessionObj("valoreCercatoLMO");
      }

    }
    /// <summary>
    /// richiesta (ri)stampa UDC
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public void ristampa()
    {
      bool fatto = false;
      // registro ri-stampa UDC
      DateTime adesso = DateTime.Now;
      // calcolo particolare...
      DS_magazzino.ElencoCartelliniRow rigaUDC;
      string particolare = "";
      try
      {
        rigaUDC = MagClass.magazzino.taCartellini.getByUdc(udcReq)[0];
        particolare = rigaUDC.Particolare;
        fatto = MagClass.magazzino.ristampaUdc(udcReq, Postazione.printer, Request.UserHostName);
      }
      catch
      {
        logger.lg.scriviLog(string.Format("Errore recupero particolare UDC Finito LM OUT {0}", udcReq), tipoLog.EXCEPTION);
      }
      if (fatto) MagClass.magazzino.taSAO.insertQuery(adesso, MagClass.magazzino.CodSoggCurrUser, Postazione.name, Postazione.IP, udcReq, particolare, "stampaUDC", "Ri-Stampato UDC Finito LM OUT");
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// udc da stampare
    /// </summary>
    protected string udcReq
    {
      get
      {
        return memLayer.ML.StringSessionObj("udcSelSAO");
      }
    }
    /// <summary>
    /// controlla particolare selezionato
    /// </summary>
    private void checkParticolare()
    {
      if (currParticolare != "")
      {
        lblParticolareAttivo.Text = string.Format("Particolare selezionato <b>{0}</b>", currParticolare);
        lblPart.Text = currParticolare;
        // aggiungo descrizione del particolare
        string descr = "";
        string disegno = "";
        try
        {
          DS_magazzino.AnagParticolariRow riga = MagClass.magazzino.taAnagPart.likeSearch(currParticolare, memLayer.ML.StringSessionObj("CodCS"))[0];
          descr = riga.DescParticolare;
          disegno = string.Format("( {0} )", riga.DisegnoGrezzo);
        }
        catch
        { }
        lblDescrAttivo.Text = descr;
        lblDisegno.Text = disegno;
      }
      else
      {
        lblParticolareAttivo.Text = "...";
        lblDescrAttivo.Text = "";
        lblDisegno.Text = "";
      }
    }
    /// <summary>
    /// effettua controlli visibilità
    /// </summary>
    private void doChecks()
    {
      checkBarcode();
      checkStampa();
      checkParticolare();
    }
    /// <summary>
    /// sistemo labels oggetti
    /// </summary>
    private void traduciObj()
    {
      // labels
      btnCerca.Text = traduci("btnSearch");
      //txtBox
      txtQta.Text = memLayer.ML.cdv("QtaImballoFiniti");
      // buttons
      btnEmptyNote.Text = traduci("btnEmptyNote");
    }
    /// <summary>
    /// restituisce il nome della pagina corrente
    /// </summary>
    protected string PagCorrente
    {
      get
      {
        string answ = "";
        Uri MyUrl = Request.Url;
        string delimStr = "/";
        char[] delimiter = delimStr.ToCharArray();
        string[] finalUrl = MyUrl.LocalPath.ToString().Split(delimiter);
        int n = finalUrl.Length;
        answ = finalUrl[n - 1].ToString();
        DataLayer_AnagGen.PermessiRow riga = (DataLayer_AnagGen.PermessiRow)user_std.UtSn.permessi.Select(string.Format("URL = '{0}'", answ))[0];
        answ = riga.NOME;
        return answ;
      }
    }
    /// <summary>
    /// wrapper traduzione
    /// </summary>
    /// <param name="lemma"></param>
    /// <returns></returns>
    public string traduci(object lemma)
    {
      return user_std.UtSn.Traduci(lemma.ToString());
    }
    /// <summary>
    /// indica il codice articolo correntemente selezionato
    /// </summary>
    protected string currParticolare
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("currParticolare_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("currParticolare_{0}", uid), value, memLayer.ML.confReadBool("keepParticolareSel"));
      }
    }
    /// <summary>
    /// indica se i caratteri vadano forzati a maiuscoli
    /// </summary>
    public bool forceUppercase
    {
      get
      {
        return memLayer.ML.confReadBool("forceUppercase");
      }
    }
    /// <summary>
    ///  num pezzi dell'ultimo UDC del particolare generato
    /// </summary>
    public int pezziUdc
    {
      get
      {
        int answ = 0;
        try
        {
          answ = (int)MagClass.magazzino.taCartellini.getLastByParticolareStato(memLayer.ML.StringSessionObj("CodCS"), currParticolare, statoUDC, false)[0].Qta;
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// cod imballo dell'ultimo UDC del particolare generato
    /// </summary>
    public string lastCodImb
    {
      get
      {
        string answ = "";
        try
        {
          answ = MagClass.magazzino.taCartellini.getLastByParticolareStato(memLayer.ML.StringSessionObj("CodCS"), currParticolare, statoUDC, false)[0].CodImballo;
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// decodifica il tipo barcode acquisito
    /// </summary>
    public tipoCodiceBarcode tipoBCode
    {
      get
      {
        tipoCodiceBarcode answ = tipoCodiceBarcode.ND;
        int trovati = 0;
        int matricola = -1;
        // provo a convertire in intero barcode x verifica eventuale matricola...
        try
        {
          matricola = Convert.ToInt32(barcodeIn);
        }
        catch
        { }
        // controllo non si tratti di un comando...
        string preCmd = memLayer.ML.AppConf["prefComandi"];
        if (barcodeIn.StartsWith(preCmd))
        {
          answ = tipoCodiceBarcode.Comando;
        }
        else if ((TermClass.Ter.riconosciBarcode(barcodeIn) == tipoCodiceBarcode.Particolare)) // è un particolare...
        {
          answ = tipoCodiceBarcode.Particolare;
        }
        // controllo se sia un codice IMBALLO
        else if (utils.obj.taSelImballi.getByImballo(barcodeIn).Rows.Count > 0)
        {
          // è imballo!
          answ = tipoCodiceBarcode.Imballo;
        }
        else if (barcodeIn.StartsWith(preCodSogg))
        {
          // cerco cod soggetto...
          if (DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else if (matricola >= 0)
        {
          if (DataProxy.obj.taTrascSogg.getByKey("", matricola).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else
        {
          try
          {
            // cerco tra gitterbox (UDC)...
            trovati = MagClass.magazzino.taCartellini.getByUdc(barcodeIn).Rows.Count;
            if (trovati > 0)
            {
              answ = tipoCodiceBarcode.UDC;
            }
          }
          catch
          {
          }
        }
        return answ;
      }
    }
    /// <summary>
    /// valore barcode
    /// </summary>
    public string barcodeIn
    {
      get
      {
        return txtBarcode.Text.Trim();
      }
      set
      {
        txtBarcode.Text = value;
      }
    }
    /// <summary>
    /// qta pezzi TOTALE
    /// </summary>
    public int qta
    {
      get
      {
        int qta = 0;
        try
        {
          qta = Convert.ToInt32(txtQta.Text.Trim());
        }
        catch
        { }
        return qta;
      }
      set
      {
        txtQta.Text = value.ToString();
      }
    }
    /// <summary>
    /// controlla se ci sia un barcode
    /// </summary>
    private void checkBarcode()
    {
      if (barcodeIn != "")
      {
        Postazione.messaggiText = string.Format("Barcode digitato: {0}", barcodeIn);
        switch (tipoBCode)
        {
          case tipoCodiceBarcode.Comando:
            if (barcodeIn == memLayer.ML.cdv("cmdReset"))
            {
              currParticolare = "";
              Response.Redirect(PagCorrente);
            }
            break;
          case tipoCodiceBarcode.Imballo:
            // cerco di selezionare!
            try
            {
              ddlImballi.SelectedValue = barcodeIn;
            }
            catch
            {
              Postazione.warningText = traduci("ERR-IMB-001");
              Postazione.CssClass = "stileComandoKo";
            }
            break;
          case tipoCodiceBarcode.Particolare:
            // imposto il particolare corrente
            currParticolare = barcodeIn;
            impostaParticolare();
            break;
          case tipoCodiceBarcode.UDC:
            // procedo solo se UDC esistente
            if (MagClass.magazzino.checkUDC(barcodeIn))
            {
              // calcolo nuovo particolare
              string newPart = DataProxy.obj.taCartellini.stp_getByUdc(barcodeIn)[0].Particolare;
              // 2015.09.25 salvo barcode UDC SSE NON E' un finito (flusso = "FI") --> dovrebbe evitare poi di avere relazioni UDC tra finito --> finito con consumo di uno x creazione altro...
              if (barcodeIn.IndexOf(flusso) < 0)
              {
                if (testoRicerca != newPart)
                {
                  // resetto precedente ricerca e deseleziono TUTTI gli UDC elencati SE è cambiato il particolare
                  udcSelC = string.Format("#{0}#", barcodeIn);
                }
                else
                {
                  udcSelC = string.Format("{0}#{1}#", udcSelC, barcodeIn);
                  // se era presente in elenco "P" lo elimino
                  udcSelP = udcSelP.Replace(string.Format("#{0}#", barcodeIn), "");
                }
              }
              updFiltroPart(newPart);
              //tolto x richiesta di quel pelato di Gian 2014.02.11
#if false
                            // imposto particolare!
                            currParticolare = newPart;
                            impostaParticolare(); 
#endif
            }

            break;
          case tipoCodiceBarcode.Operatore:
            // calcolo matricola utente
            int MatrUtente = -1;
            string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
            if (barcodeIn.StartsWith(preCodSogg))
            {
              MatrUtente = DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0)[0].CodMatricola;
            }
            else
            {
              MatrUtente = Convert.ToInt32(barcodeIn);
            }
            if (MatrUtente >= 0)
            {
              // salvo in sessione operatore con AUTH
              OpAuth.startOpAuth(MatrUtente);
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRec");
              Postazione.CssClass = "stileComandoOk";
              Response.Redirect(user_std.pagCorrente);
            }
            else
            {
              Postazione.messaggiText += " - codice <b>non riconosciuto</b>!";
              Postazione.CssClass = "stileComandoND";
            }
            break;
          default:
            // cerco se sia "0" = reset utente...
            if (barcodeIn == memLayer.ML.CRS("resetCodSogg"))
            {
              // salvo in sessione operatore con AUTH
              OpAuth.stopAuth();
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRem");
              Postazione.CssClass = "stileComandoOk";
              Response.Redirect(user_std.pagCorrente);
            }
            Postazione.messaggiText += " - codice <b>non riconosciuto</b>!";
            Postazione.CssClass = "stileComandoND";
            break;
        }
        barcodeIn = "";
      }
#if false
            else
            {
                Postazione.messaggiText = traduci("AttesaBCode");
                Postazione.CssClass = "stileAttesa";
            } 
#endif
      //grView.DataBind();
      txtBarcode.Focus();
    }
    /// <summary>
    /// imposto i dati dal particolare corrente
    /// </summary>
    private void impostaParticolare()
    {
      // controllo esista il particolare scansionato
      if (DataProxy.obj.taAnagParticolari.getByParticolare(currParticolare).Rows.Count == 0)
      {
        currParticolare = "";
        Postazione.messaggiText += " - codice particolare non valido / non trovato in RILPRO.";
        Postazione.CssClass = "stileComandoKo";
      }
      else
      {
        Postazione.messaggiText += " - impostato particolare!";
        Postazione.CssClass = "stileComandoOk";
      }
      // leggo la qta dell'ultimo UDC del particolare, SE C'E', e la imposto...
      if (pezziUdc > 0)
      {
        txtQta.Text = pezziUdc.ToString();
      }
      else // rimette default
      {
        txtQta.Text = memLayer.ML.cdv("QtaImballoFiniti");
      }
      if (lastCodImb != "")
      {
        selezionaImballo();
      }
    }
    /// <summary>
    /// update del filtro su particolare x grview UDC caricati in linea
    /// </summary>
    /// <param name="newPart"></param>
    private void updFiltroPart(string newPart)
    {
      if (testoRicerca != newPart)
      {
        // imposto filtraggio x particoalre nell'elenco degli UDC della linea...
        testoRicerca = newPart;
        // salvo UDC da selezionare come consumo COMPLETO
        salvaCerca();
      }
      else
      {
        doUpdate();
      }
    }
    /// <summary>
    /// aggiorna tabella + focus a barcode
    /// </summary>
    public void doUpdate()
    {
      idxCella = Postazione.currIdxCella;
      checkStampa();
      grView.DataBind();
      txtBarcode.Focus();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// controllo l'abilitazione alla stampa UDC:
    /// - particolare ok
    /// - qta > 0
    /// - udc da consumo totale/parziale
    /// altrimenti disabilito btn stampa
    /// </summary>
    private void checkStampa()
    {
      bool stampaOk = false;
      //controllo siano inseriti valori qta
      if (qta > 0)
      {
        // controllo ci siano particolare e ci sia selezionato almeno un UDC
        if (currParticolare != "" && ((udcSelC.Replace("#", "").Length > 1) || (udcSelP.Replace("#", "").Length > 1)))
        {
          stampaOk = true;
        }
      }
      divNote.Visible = stampaOk;
    }
    /// <summary>
    /// genera i barcode di
    /// - trattamenti
    /// - nuovo x pezzi liquidi
    /// e lancia la relativa stampa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnStampa_Click(object sender, EventArgs e)
    {
      bool needsRedirect = false;
      string[] stringSeparators = new string[] { "#" };
      // verifico postazione x procedere...
      if (Postazione.printer != "n.d.")
      {
        // verifico auth utente OPPURE se NON sia richiesta...
        if (OpAuth.isAuth || !OpAuth.opAuthReq)
        {
          // controllo UDC in ingresso, che siano tutti con uguale particolare e DIVERSO da ""
          string partUdcIn = "";
          try
          {
            string fullUdc = string.Format("{0}#{1}", udcSelC, udcSelP);
            // ciclo tutti gli UDC consumati P e C e verifico loro particolare
            if (fullUdc.Replace("#", "").Length > 1)
            {
              string[] elencoUDC;
              elencoUDC = fullUdc.Split(stringSeparators, StringSplitOptions.RemoveEmptyEntries);
              partUdcIn = checkPartUDC(elencoUDC);
            }
          }
          catch
          { }
          if (partUdcIn != "")
          {
            // controllo da distinta base coerenza particolare IN/OUT
            bool partDistintaOk = false;
            try
            {
              if (MagClass.magazzino.taPartIO.GetData(currParticolare, partUdcIn, true)[0].Trovati > 0) partDistintaOk = true;
            }
            catch
            { }
            if (partDistintaOk)
            {
              string newUdcChild = "";
              int qta = memLayer.ML.cdvi("QtaImballoFiniti");
              string noteTrim = txtNote.Text.Trim();
              // 2014.05.08 tolto e spostato in classe postazione gestione NOME LINEA x note, da verificare...
#if false
                        string nomeLinea = ddlLinea.SelectedItem.Text;
#endif
              noteTrim = string.Format("{0}{1}{2}", Postazione.currNomeLinea, Environment.NewLine, noteTrim);
              try
              {
                qta = Convert.ToInt32(txtQta.Text);
              }
              catch
              { }
              // effettuo controlli che cod_soggetto e cod particolare siano disponibili...
              string codSogg = "";
              string particolare = "";
              try
              {
                codSogg = MagClass.magazzino.CodSoggCurrUser;
                particolare = currParticolare;
              }
              catch
              {
              }
              if (codSogg != "" && particolare != "")
              {
                // genero cartellino
                DateTime adesso = DateTime.Now;
                try
                {
                  string codImballo = "";
                  try
                  {
                    codImballo = ddlImballi.SelectedValue;
                  }
                  catch
                  {
                    codImballo = memLayer.ML.cdv("CodImballoFiniti");
                  }
                  // se NON HA selezionato prendo default...
                  if (string.IsNullOrEmpty(codImballo) || codImballo == "-")
                  {
                    codImballo = memLayer.ML.cdv("CodImballoFiniti");
                  }
                  // creo nuovo UDC FINITO OUT multiple
                  newUdcChild = MagClass.magazzino.creaUdc(flusso, "", currParticolare, "", "", "", "", "", 0, codImballo, "U", MagClass.magazzino.CodSoggCurrUser, qta, 0, 0, adesso, 0, statoUDC, memLayer.ML.cdvi("IdxPosizioneFiniti"), "IdxPosizioneFiniti", eventoUDC, noteTrim, "", adesso.Year, Request.UserHostName);

                  if (OpAuth.isAuth)
                  {
                    // salvo attributo dell'OpAuth...
                    MagClass.magazzino.taAtt2UDC.Insert(newUdcChild, memLayer.ML.CRS("attrOpAuth"), OpAuth.currAuth.CodSoggetto, DateTime.Now, codSogg);
                    // consumo una auth...
                    OpAuth.currAuth.remAuth--;
                    if (OpAuth.currAuth.remAuth == 0)
                    {
                      OpAuth.stopAuth();
                      needsRedirect = true;
                    }
                  }

                  // registro creazione nuovo UDC
                  MagClass.magazzino.taSAO.insertQuery(adesso, codSogg, Postazione.name, Postazione.IP, newUdcChild, particolare, "creaUDC", string.Format("Creato nuovo UDC Finito LM OUT, qta: {0} {1}", qta, noteTrim));
                }
                catch (Exception exc)
                {
                  httpLog(string.Format("Errore creazione UDC Finito LM OUT: {0}", exc), tipoLog.EXCEPTION);
                }
                // devo gestire associazione e consumo cartellini FUSI
                if (newUdcChild != "")
                {
                  string[] UDC_P;
                  // ASSOCIO tutti gli UDC consumati sia Parziali che Completi al nuovo UDC
                  if (udcSelP.Replace("#", "").Length > 1)
                  {
                    // associo
                    UDC_P = udcSelP.Split(stringSeparators, StringSplitOptions.RemoveEmptyEntries);
                    //UDC_P = SteamWare.StringSplitter.CSplitter.Split(udcSelP, "#", false, 0, SteamWare.StringSplitter.ComparisonMethod.Text);
                    associaUdc(newUdcChild, UDC_P);
                  }
                  if (udcSelC.Replace("#", "").Length > 1)
                  {
                    // associo
                    UDC_P = udcSelC.Split(stringSeparators, StringSplitOptions.RemoveEmptyEntries);
                    //UDC_P = SteamWare.StringSplitter.CSplitter.Split(udcSelC, "#", false, 0, SteamWare.StringSplitter.ComparisonMethod.Text);
                    associaUdc(newUdcChild, UDC_P);
                    // consumo gli UDC indicati come "C"
                    consumaUdc(UDC_P);
                  }

                  // ora stampo il nuovo cartellino!!!
                  MagClass.magazzino.stampaUdc(newUdcChild, Postazione.printer, tipoCartellino.cartFiniti, Request.UserHostName);
                  // incremento timing...
                  adesso = DateTime.Now;
                  adesso = adesso.AddSeconds(2);
                  // registro stampa nuovo UDC
                  MagClass.magazzino.taSAO.insertQuery(adesso, codSogg, Postazione.name, Postazione.IP, newUdcChild, particolare, "stampaUDC", "Stampato UDC Finito LM OUT");
                }
                // resetto
                doResetData();
              }
              else
              {
                httpLog(string.Format("Finiti LM OUT, Errore persi utente/particolare, ricarico!"), tipoLog.ERROR);
                Response.Redirect("~/login.aspx");
              }
            }
            else
            {
              httpLog(string.Format("Finiti LM OUT, Errore controllo coerenza particolari da distinta base!"), tipoLog.ERROR);
              Postazione.messaggiText += "Errore particolari UDC da controllo distinta base";
              Postazione.CssClass = "stileComandoND";
            }
          }
          else
          {
            httpLog(string.Format("Finiti LM OUT, Errore controllo coerenza elenco particolari IN!"), tipoLog.ERROR);
            Postazione.messaggiText += "Errore particolari UDC da consumare non coerenti";
            Postazione.CssClass = "stileComandoND";
          }
        }
        else
        {
          Postazione.messaggiText = traduci("noOpAuth");
          Postazione.CssClass = "stileComandoKo";
          httpLog(string.Format("Errore manca OpAuth x UDC anime"), tipoLog.ERROR);
        }
      }
      else
      {
        Response.Redirect("~/menu.aspx");
      }
      doUpdate();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
      if (needsRedirect)
      {
        Response.Redirect(user_std.pagCorrente);
      }
    }
    /// <summary>
    /// effettua il consumo di tutti gli UDC inviati come array di stringhe
    /// </summary>
    /// <param name="UDC_P"></param>
    private void consumaUdc(string[] UDC_P)
    {
      if (UDC_P.Length > 0)
      {
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          // se UDC è NON vuoto ed esiste
          if (udc_p != "" && MagClass.magazzino.checkUDC(udc_p))
          {
            // se è consumabile (IdxPosizione > 0)...
            if (MagClass.magazzino.udcMpIsConsumabile(udc_p))
            {
              // consumo UDC
              MagClass.magazzino.scaricaUdcMpWip(udc_p, Request.UserHostName);
              // sposta UDC da posizione corrente a nessuna...
            }
          }
        }
      }
    }
    /// <summary>
    ///associa nuovo UDC ad elenco UDC
    /// </summary>
    /// <param name="newUdcChild">UDC da associare come child</param>
    /// <param name="UDC_P">vettore di UDC da associare come parent</param>
    private void associaUdc(string newUdcChild, string[] UDC_P)
    {
      if (UDC_P.Length > 0)
      {
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          // se UDC è NON vuoto ed esiste
          if (udc_p != "" && MagClass.magazzino.checkUDC(udc_p))
          {
            MagClass.magazzino.associaUdcParent(newUdcChild, udc_p, true);
          }
        }
      }
    }
    /// <summary>
    /// verifica che il vettore di UDC abbia tutto lo stesso particolare e lo restituisce, altrimenti restituisce ""
    /// </summary>
    /// <param name="UDC_P">vettore di UDC da verificare</param>
    private string checkPartUDC(string[] UDC_P)
    {
      string answ = "";
      if (UDC_P.Length > 0)
      {
        // imposto il primo particolare...
        answ = MagClass.magazzino.getParticolareByUDC(UDC_P[0]);
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          if (MagClass.magazzino.getParticolareByUDC(udc_p) != answ) answ = ""; // se uno è diverso "azzero"
        }
      }
      return answ;
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string _testoPre)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + _testoPre);
      return answ;
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string testoLog, tipoLog tipo)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + testoLog, tipo);
      return answ;
    }
    /// <summary>
    /// effettua reset dati
    /// </summary>
    public void doResetData()
    {
      // resetto i dati QtaTot e particolare...
      qta = 0;
      currParticolare = "";
      txtQta.Text = "";
      testoRicerca = "";
      salvaCerca();
      doChecks();
    }
    /// <summary>
    /// svuoto le note
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnEmptyNote_Click(object sender, EventArgs e)
    {
      txtNote.Text = "";
      Postazione.messaggiText = traduci("AttesaBCode");
      Postazione.CssClass = "stileAttesa";
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// passo alla modalità IN
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnIn_Click(object sender, EventArgs e)
    {
      Response.Redirect("LavorMeccIN.aspx");
    }

    /// <summary>
    /// effettua refresh (su db) del blocco postazione
    /// </summary>
    /// <param name="codLinea"></param>
    private void refreshBloccoPost(string codLinea)
    {
      // resetto usi linee precedenti..
      MagClass.magazzino.taAL.resetPost(Postazione.name);
      // se la linea non è "base" = "Sel linea", finisce x "0"
      if (codLinea.Substring(codLinea.Length - 1) != "0")
      {
        // salvo su DB che sto occupando linea...
        MagClass.magazzino.taAL.updatePost(codLinea, Postazione.name);
      }
    }
    /// <summary>
    /// CODICE cella associata alla linea corrente
    /// </summary>
    protected string codCella
    {
      get
      {
        string answ = "";
        if (memLayer.ML.isInSessionObject("codCellaLM"))
        {
          answ = memLayer.ML.StringSessionObj("codCellaLM");
        }
        return answ;
      }
      set
      {
        memLayer.ML.setSessionVal("codCellaLM", value);
      }
    }
    /// <summary>
    /// codice della linea corrente
    /// </summary>
    protected string currCodLinea
    {
      get
      {
        string answ = "";
        if (memLayer.ML.isInSessionObject(string.Format("LineaOut-{0}", uid)))
        {
          answ = memLayer.ML.StringSessionObj(string.Format("LineaOut-{0}", uid));
        }
        return answ;
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("LineaOut-{0}", uid), value);
      }
    }
    /// <summary>
    /// cambiato valore in ricerca
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtCerca_TextChanged(object sender, EventArgs e)
    {
      // se è nuovo il testo resetto
      if (testoRicerca != SteamWare.memLayer.ML.StringSessionObj("valoreCercatoLMO"))
      {
        udcSelC = "";
        udcSelP = "";
      }
      salvaCerca();
    }
    /// <summary>
    /// effettuato reset
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lnkReset_Click(object sender, EventArgs e)
    {
      testoRicerca = "";
      salvaCerca();
    }
    /// <summary>
    /// pressione del button di ricerca
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnCerca_Click(object sender, EventArgs e)
    {
      salvaCerca();
    }

    /// <summary>
    /// testo ricerca trimmato da spazi
    /// </summary>
    protected string testoRicerca
    {
      get
      {
        return txtCerca.Text.Trim();
      }
      set
      {
        txtCerca.Text = value;
      }
    }
    /// <summary>
    /// salvo ricerca particolare
    /// </summary>
    protected void salvaCerca()
    {
      if (string.IsNullOrEmpty(testoRicerca))
      {
        SteamWare.memLayer.ML.emptySessionVal("valoreCercatoLMO");
        udcSelC = "";
        udcSelP = "";
      }
      else
      {
        SteamWare.memLayer.ML.setSessionVal("valoreCercatoLMO", testoRicerca);
      }
      // raise dell'evento
      if (eh_nuovaRicerca != null)
      {
        eh_nuovaRicerca(this, new EventArgs());
      }
      doUpdate();
    }
    protected void grView_PageIndexChanged(object sender, EventArgs e)
    {
      // fix dell'ODS
      checkFixOds();
    }
    protected void grView_Sorted(object sender, EventArgs e)
    {
      // fix dell'ODS
      checkFixOds();
    }
    /// <summary>
    /// aggiorno ods al binding..
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ods_DataBinding(object sender, EventArgs e)
    {
      // fix dell'ODS
      checkFixOds();
    }
    /// <summary>
    /// verifica se attivo filtro company e imposta ods di conseguenza...
    /// </summary>
    private void checkFixOds()
    {
    }
    /// <summary>
    /// traduce gli header delle colonne
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void grView_DataBound(object sender, EventArgs e)
    {
      if (grView.Rows.Count > 0)
      {
        LinkButton lb;
        // aggiorno gli headers        
        foreach (TableCell cella in grView.HeaderRow.Cells)
        {
          try
          {
            lb = (LinkButton)cella.Controls[0];
            lb.Text = traduci(lb.Text);
          }
          catch
          { }
        }
        int totRecord = grView.Rows.Count + grView.PageSize * (grView.PageCount - 1);
        lblNumRec.Text = string.Format("{0} records of ~ {1}", grView.Rows.Count, totRecord);
      }
      else
      {
        lblNumRec.Text = "";
      }
    }

    protected void rbl_DataBinding(object sender, EventArgs e)
    {
      RadioButtonList rbl = (RadioButtonList)sender;
      if (udcSelC.IndexOf(rbl.ToolTip) >= 0)
      {
        rbl.SelectedValue = "C";
      }
      else if (udcSelP.IndexOf(rbl.ToolTip) >= 0)
      {
        rbl.SelectedValue = "P";
      }
    }

    protected void rbl_DataBound(object sender, EventArgs e)
    {

    }
    /// <summary>
    /// selezione UDC da elenco
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void rbl_SelectedIndexChanged(object sender, EventArgs e)
    {
      RadioButtonList rbl = (RadioButtonList)sender;
      if (rbl.SelectedValue == "C")
      {
        udcSelC = string.Format("{0}#{1}#", udcSelC, rbl.ToolTip);
        // se era presente in elenco "P" lo elimino
        udcSelP = udcSelP.Replace(string.Format("#{0}#", rbl.ToolTip), "");
      }
      else
      {
        udcSelP = string.Format("{0}#{1}#", udcSelP, rbl.ToolTip);
        // se era presente in elenco "C" lo elimino
        udcSelC = udcSelC.Replace(string.Format("#{0}#", rbl.ToolTip), "");
      }
      // calcolo il particolare da selezionare...
      string newPart = DataProxy.obj.taCartellini.stp_getByUdc(rbl.ToolTip)[0].Particolare;
      updFiltroPart(newPart);
      checkStampa();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }

    /// <summary>
    /// preseleziono (se possibile) imballo...
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ddlImballi_DataBound(object sender, EventArgs e)
    {
      selezionaImballo();
    }
    /// <summary>
    /// seleziona imballo corretto
    /// </summary>
    private void selezionaImballo()
    {
      string codImb = "";
      // cerco se c'è un imballo x particolare corrente...
      if (currParticolare != "")
      {
        codImb = lastCodImb;
      }
      else
      {
        codImb = memLayer.ML.cdv("CodImballoFiniti");
      }
      try
      {
        // preseleziono
        ddlImballi.SelectedValue = codImb;
      }
      catch
      { }
    }
  }
}